/***************************************************************************
                          HermodResponse.h  -  description
                             -------------------
    begin                : Fri Feb 21 2003
    copyright            : (C) 2003 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU LGPL (Lesser general Public License) 
 *   as published by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/lesser.html or in the file copying.txt
 *
 ***************************************************************************/
#ifndef _HERMODRESPONSE_H_
#define _HERMODRESPONSE_H_

#include "HermodFault.h"
#include "HermodParameter.h"



class HermodResponse
{
	private:
		HermodFault *m_fault;
		vector<HermodParameter> m_params;
		string m_connectionId;
		
	public:
		HermodResponse() {m_fault=NULL; m_connectionId="";};
		~HermodResponse() {if (m_fault) delete m_fault;};

		vector<HermodParameter> getParams() {return m_params;}
		void setParams(vector<HermodParameter> params) {m_params.clear(); m_params = params;};

		HermodFault *getFault() {return m_fault;}
		void setFault(HermodFault *fault) {if (m_fault) delete m_fault; m_fault = fault;};
		BOOL generatedFault() {if (m_fault) return TRUE; return FALSE;};

		const char *getConnectionId() {return m_connectionId.c_str();};
		string getConnectionIdString() {return m_connectionId;};
		void setConnectionId(const char *conn) {m_connectionId = conn;};
		void setConnectionId(string conn) {m_connectionId = conn;};
};//HermodResponse



#endif
