/*
 * Element.java
 *
 * Created on July 30, 2001, 2:53 PM
 */

package com.hbaastrup.MiniXML;

/**
 *
 * @author  Henrik Baastrup (c) 2001
 * @version 0.1
 *
 * Home page: http://digilander.iol.it/hba/Linux/index.html
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 */
import java.util.*;

class ElementAttribute
{
    public String name = "";
    public String value = "";
}//ElementAttribute

public class Element 
{
    private String name = "";
    private String value = "";
    private Vector attributes = null;
    private Vector subElements = null;
    private Enumeration subElementsList = null;
    private Element parrent = null;
    private boolean found = false;
    
    public void setName(String name) { this.name = new String(name).trim(); }
    public void setName(byte[] name, int len) { this.name = new String(name,0,len).trim(); }
    public String getName() { return name; }
    
    public void setValue(String value) { this.value = new String(value).trim(); }
    public void setValue(byte[] value, int len) { this.value = new String(value,0,len).trim(); }
    public String getValue() { return value; }
    
    public void addAttribute(ElementAttribute attr)
    {
        if (attributes==null) attributes = new Vector();
        attributes.addElement(attr); 
    }
    
    public Vector getAttributes() { return attributes; }
    
    public String getAttribute(String attrName)
    {
        ElementAttribute attr;
        
        if (attributes==null) return null;
        Enumeration attrList = attributes.elements();
        while (attrList.hasMoreElements()) {
            attr = (ElementAttribute) attrList.nextElement();
            if (attr.name.equals(attrName)) return attr.value;
        }
        return null;
    }//getAttribute
    
    public void addElement(Element e) 
    {
        if (subElements==null) subElements = new Vector();
        e.setParrent(this);
        subElements.addElement(e);
    }//addElement
    
    public Vector getSubElements() {return subElements; }
    
    public Element getFirstSubElement()
    {
        if (subElements==null) return null;
        subElementsList = subElements.elements();
        return (Element)subElementsList.nextElement();
    }//getFirstSubElement
    
    public Element getNextSubElement()
    {
        if (subElementsList==null) return null;
        try {
            return (Element)subElementsList.nextElement();
        } catch (Exception ex) { return null; }
    }//getNextSubElement
    
    public void setParrent(Element e) { parrent = e; }
    public Element getParrent() { return parrent; }
    
    public void initSearch()
    {
        Element subElm;

        found = false;
        subElm = getFirstSubElement();
        while (subElm!=null) {
            subElm.initSearch();
            subElm = getNextSubElement();
        }
    }//initSearch
    
    public Element searchFor(String name)
    {
        Element subElm;

        if (this.name.equals(name) && !found) {
            found = true;
            return this;
        }
        subElm = getFirstSubElement();
        while (subElm!=null) {
            subElm = subElm.searchFor(name);
            if (subElm!=null) {
                if (subElm.found) return subElm;
            }
            subElm = getNextSubElement();
        }
        return null;
    }//searchForFirst
}//Element
