/***************************************************************************
                          HermodTest.cpp  -  description
                             -------------------
    begin                : Fri Jan 3 2003
    copyright            : (C) 2003 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU GPL (General Public License) as published
 *   by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/gpl.html or in the file copying.txt
 *
 ***************************************************************************/

#include "Hermod.h"

int main(int argc, char *argv[])
{
	Hermod hermod;
	Response *response;
	char xmlInStr[1024] = "<?xml version=\"1.0\"?> \
		                   <methodCall> \
						     <methodName>rs17-connect-disconnect</methodName> \
							 <params> \
							   <param name='rs-17-input'> \
								 <string>100D000100010ECHO    Pipo</string> \
							    </param> \
							 </params> \
						   </methodCall>";
	char *xmlOutStr, *connId;

#ifdef USE_PERCOMM
	strcpy(HllapiFileName,"C:\\Program Files\\Personal Communications\\EHLAPI32.dll");
	strcpy(PcsapiFileName,"C:\\Program Files\\Personal Communications\\pcsapi32.dll");

	hermod.init("C:\\Projects\\hermod\\config.xml");
//	hermod.init("C:\\Projects\\hermod\\config.xml", FALSE);
#else
	hermod.init("/hbaastrup/projects/hermod/config.xml");
#endif
	hermod.setLoginUser("CS4AA06");
	hermod.setLoginPassword("abcde01");
	response = hermod.invoke(xmlInStr);
	xmlOutStr = response->getXmlString();
	printf("%s\n\n\n",xmlOutStr);

	strcpy(xmlInStr,"<?xml version=\"1.0\"?><methodCall><methodName>get-free-connection</methodName><params></params></methodCall>");
	response = hermod.invoke(xmlInStr);
	connId = response->getConnectionId();

	sprintf(xmlInStr,"<?xml version=\"1.0\"?><methodCall connectionId='%s'><methodName>rs17-connect</methodName><params></params></methodCall>",connId);
	response = hermod.invoke(xmlInStr);
	connId = response->getConnectionId();

	sprintf(xmlInStr,"<?xml version=\"1.0\"?><methodCall connectionId='%s'><methodName>rs17-disconnect</methodName><params></params></methodCall>",connId);
	response = hermod.invoke(xmlInStr);
	connId = response->getConnectionId();

	sprintf(xmlInStr,"<?xml version=\"1.0\"?><methodCall connectionId='%s'><methodName>release-connection</methodName><params></params></methodCall>",connId);
	response = hermod.invoke(xmlInStr);

	return 1;
}

