/***************************************************************************
                          Element.h  -  description
                             -------------------
    begin                : Sun Apr 21 2002
    copyright            : (C) 2002 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU LGPL (Lesser general Public License) 
 *   as published by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/lesser.html or in the file copying.txt
 *
 ***************************************************************************/
#ifndef _ELEMENT_H_
#define _ELEMENT_H_

#include <stdio.h>
#include <string.h>
#include <malloc.h>

class ElementAttribute
{
	public:
		char *mName;
		char *mValue;
		ElementAttribute *mNext;

		ElementAttribute() {mName=NULL; mValue=NULL; mNext=NULL;};
		~ElementAttribute() {if (mName) free(mName); if (mValue) free(mValue);};
};//ElementAttribute


class Element
{
	friend class MiniXML;

	private:
		char *mName;
		char *mValue;
		ElementAttribute *mFirstAttribute;
		ElementAttribute *mLastAttribute;
		Element *mNextElement;
		Element *mFirstSubElement;
		Element *mLastSubElement;
		Element *mActualeSubElement;
		Element *mParrent;
		int mSearchFound;
		int mIndex;

	private:
		void SetParrent(Element *elm) {mParrent = elm;};

	public:
		Element();
		~Element();

		void SetName(char *);
		char *GetName() {return mName;}
		void SetValue(char *);
		char *GetValue() {return mValue;}
		void SetIndex(int inx) {mIndex = inx;};
		int GetIndex() {return mIndex;};
		void AddAttribute(ElementAttribute *);
		ElementAttribute *GetAttributes() {return mFirstAttribute;};
		char *GetAttrubuteValue(char *);
		void DeleteAttrubutes();
		void AddSubElement(Element *elm);
		void AddSubElementFirst(Element *elm);
		void SetNextElement(Element *elm) {mNextElement = elm;};
		Element *GetNextElement() {return mNextElement;};
		Element *GetSubElements() {return mFirstSubElement;}
		Element *GetFirstSubElement() {mActualeSubElement = mFirstSubElement; return mActualeSubElement;};
		Element *GetNextSubElement() {if (mActualeSubElement==NULL) return NULL; mActualeSubElement = mActualeSubElement->mNextElement; return mActualeSubElement;};
		void DeleteNextElements();
		void DeleteSubElements();
		void CutOutOfTree();
		Element *GetParrent() {return mParrent;}
		void InitSearch();
		Element *SearchFor(char *);
};//Element

#endif
