/***************************************************************************
                            Log.h  -  description
                             -------------------
    begin                : Mon June 24 2002
    copyright            : (C) 2002 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU LGPL (Lesser general Public License) 
 *   as published by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/lesser.html or in the file copying.txt
 *
 ***************************************************************************/
#ifndef _LOG_H_
#define _LOG_H_

#include <stdio.h>
#include <fstream.h>
#include <iostream.h>

#ifdef WIN32
#include "ThreadIntefaceWin32.h"
#elif defined(POSIX_THREAD)
#include "ThreadIntefacePthread.h"
#endif

#ifndef BOOL
#define BOOL int
#endif
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

class Log
{
	private:
		int m_logLevel;
		char m_logName[1025];
		ofstream m_oStream;
		BOOL m_isOpen;
		int m_openDay;
		MutexClass m_mutex;

		void rotateLogs();

	public:
		Log();
		Log(const char *logName);
		~Log();
		void open(const char *logName);
		void close();
		void logWrite(const char *string);
		void logWrite(int level, const char *string);
		void setLogLevel(int level) {m_logLevel = level;};
		char *getLogName() {return m_logName;};
};//Log

#endif
