/***************************************************************************
                          ThreadIntefacePthread.h  -  description
                             -------------------
    begin                : Tue May 14 2002
    copyright            : (C) 2002 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU GPL (General Public License) as published
 *   by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/gpl.html or in the file copying.txt
 *
 ***************************************************************************/
#ifdef POSIX_THREAD
#ifndef _THREDINTERFACE_H_
#define _THREDINTERFACE_H_

#include <pthread.h>

class MutexClass
{
	private:
		pthread_mutex_t m_mutex;

	public:
		MutexClass();
		~MutexClass();
		int lock();
		int unlock();
};//MutexClass


class Event
{
	private:
		pthread_mutex_t m_cond_mutex;
		pthread_cond_t m_cond;
		int m_isMutextLocked;

	public:
		Event();
		~Event();
		int wait();
		int set();
		int lockEventMutext();
};//Event


class ThreadClass
{
	private:
		pthread_t  m_threadId;
		void *m_threadArg;
		void *(*m_startRutine)(void *);
		int m_doNotKillMe;

	public:
		ThreadClass(void *(*)(void *), void *);
		~ThreadClass();
		int start();
		void kill();
		void *callStartRutine();
		void doNotKillMe() {m_doNotKillMe = 1;};
};//ThreadClass

#ifndef LOCAL_INCLUDE
extern void ThreadSleep(int sec);
#endif

#endif
#endif
