//
//  Filename: ATMMailServerMsg.h		Auther: henrik Baastrup (c) 2001 EDS
//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: EVMSG_INSTALLED
//
// MessageText:
//
//  The %1 service was installed.
//
#define EVMSG_INSTALLED                  0x00000064L

//
// MessageId: EVMSG_REMOVED
//
// MessageText:
//
//  The %1 service was removed.
//
#define EVMSG_REMOVED                    0x00000065L

//
// MessageId: EVMSG_STARTED
//
// MessageText:
//
//  The %1 service was started.
//
#define EVMSG_STARTED                    0x00000066L

//
// MessageId: EVMSG_STOPED
//
// MessageText:
//
//  The %1 service was stoped.
//
#define EVMSG_STOPED                     0x00000067L

//
// MessageId: EVMSG_INSTALL_ERR
//
// MessageText:
//
//  Error in installing the %1 service: %2.
//
#define EVMSG_INSTALL_ERR                0xC0000068L

//
// MessageId: EVMSG_REMOVED_ERR
//
// MessageText:
//
//  Error in removed the %1 service: %2.
//
#define EVMSG_REMOVED_ERR                0xC0000069L

//
// MessageId: EVMSG_DLLLOAD_ERR
//
// MessageText:
//
//  The DLL %1 could not be loaded.
//
#define EVMSG_DLLLOAD_ERR                0xC000006AL

//
// MessageId: EVMSG_FUNCLOAD_ERR
//
// MessageText:
//
//  Could not load function from DLL: %1.
//
#define EVMSG_FUNCLOAD_ERR               0xC000006BL

//
// MessageId: EVMSG_REGREAD_ERR
//
// MessageText:
//
//  Could not read a key from the regeristry %1.
//
#define EVMSG_REGREAD_ERR               0xC000006CL

//
// MessageId: EVMSG_MAILCHECK_ERR
//
// MessageText:
//
//  Mail check error %1.
//
#define EVMSG_HERMOD_ERR               0xC000006CL

